'$INCLUDE: 'directqb.bi'
DECLARE SUB DrawScreen (update%)
DECLARE SUB EndProgram ()
DECLARE SUB Init ()
DECLARE SUB LoadFile (File$)

DIM SHARED File(1 TO 2048) AS STRING
DIM SHARED TopLine AS INTEGER
DIM SHARED NumOfLines AS INTEGER

DIM CurFile AS STRING, ScrollDelay AS INTEGER

dum$ = COMMAND$
IsThere% = INSTR(dum$, "-")

IF IsThere% THEN
 CurFile = LEFT$(dum$, IsThere%)
 arg$ = MID$(dum$, IsThere% + 1, 1)

checkarg:
 SELECT CASE LCASE$(arg$)
  CASE "?"
   CLS
   PRINT "USAGE:"
   PRINT "QFTView -? | FILENAME.TXT [-dSCROLLDELAY#]"
   PRINT
   PRINT "e.g.:"
   PRINT "QFTView somefile.txt -d15#"
   PRINT "Will display the file somefile.txt and set the scrolling delay to 15"
   END
  CASE "d"
   argend% = INSTR(IsThere%, dum$, "#")
   arglen% = argend% - IsThere%
   ScrollDelay = VAL(MID$(dum$, IsThere% + 2, arglen%))
 END SELECT

ELSE
 CurFile = dum$
 ScrollDelay = 0
END IF

LoadFile CurFile
Init
DrawScreen 1

DO

 IF DQBkey(KEYUP) THEN
  IF TopLine > 1 THEN TopLine = TopLine - 1: change = 1
 ELSEIF DQBkey(KEYDOWN) THEN
  IF TopLine < NumOfLines - 17 THEN TopLine = TopLine + 1: change = 1
 ELSEIF DQBkey(KEYESC) THEN
  quit = 1
 ELSEIF DQBkey(73) THEN
  IF TopLine > 15 THEN TopLine = TopLine - 15: change = 1
 ELSEIF DQBkey(81) THEN
  IF TopLine < NumOfLines - 17 - 15 THEN TopLine = TopLine + 15: change = 1
 END IF

 IF change = 1 THEN
  change = 0
  DrawScreen 1
 
  '/* Scrolling delay */
  IF ScrollDelay >= 1 THEN DQBwait ScrollDelay
 END IF

LOOP UNTIL quit = 1

EndProgram

REM $DYNAMIC
SUB DrawScreen (update%)
 DQBboxf 1, 0, 0, 319, 10, 1
 DQBboxf 1, 0, 11, 319, 188, 7
 DQBboxf 1, 0, 189, 319, 199, 8

 DQBprint 1, "QFT viewer by Zap/QGZ", CENTERED, 1, 15
 DQBprint 1, "Use arrow keys + PgUp & PgDown to scroll", 1, 190, 7

 x% = 11
 FOR a = TopLine TO TopLine + 17
  DQBprint 1, File(a), 1, x%, 15
  x% = x% + 10
 NEXT
 IF update THEN DQBcopyLayer 1, VIDEO
END SUB

SUB EndProgram
 DQBclose
 END
END SUB

SUB Init
IF DQBinit(1, 0, 0) THEN PRINT "Internal Error, aborting program"
DQBinitVGA
DQBinstallKeyboard

TopLine = 1
END SUB

SUB LoadFile (File$)
OPEN File$ FOR INPUT AS #1
 DO
  linenumber% = linenumber% + 1
  LINE INPUT #1, File(linenumber%)
 LOOP UNTIL EOF(1)
CLOSE
NumOfLines = linenumber%
END SUB

